/*----------------------------------------------------------------------------*/
/* Teknisa Sistemas Integrados                                                */
/* 2871_PEDSTPS_GERA_SUGCOMPRA_BDL.SQL                                        */
/* Autor: Diego Gonalves                                                     */
/* Data: 12/01/2010                                                           */
/* Descrio:                                                                 */
/*    Gerar sugesto para produtos da composio.                             */
/*----------------------------------------------------------------------------*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'GERA_SUGESTAO_COMPRA_BDL ' AND
                 TYPE = 'P' 		      AND
	              U.UID = O.UID           AND
	              U.NAME = USER)
DROP PROCEDURE GERA_SUGESTAO_COMPRA_BDL
GO

CREATE PROCEDURE GERA_SUGESTAO_COMPRA_BDL (@P_CDFILIAL     VARCHAR(4),
                                           @P_CDOPERADOR   VARCHAR(12),
                                           @P_DTPEDINI     DATETIME,
                                           @P_DTPEDFIN     DATETIME,
                                           @P_DTENTINI     DATETIME,
                                           @P_DTENTFIN     DATETIME,
                                           @P_IDSITITEMPED VARCHAR(10),
                                           @P_CDFILIDEST   VARCHAR(300),
                                           @P_CDCLIENTE    VARCHAR(300),
                                           @P_IDGERASOLCMP VARCHAR(1),
                                           @P_NRSUGCOMPRA  VARCHAR(20),
                                           @P_CDPRODINI    VARCHAR(20),
                                           @P_CDPRODFIN    VARCHAR(20),
                                           @P_DTENTSOLI    DATETIME,
                                           @P_IDMENSSOLI   VARCHAR(10)OUTPUT)
AS
BEGIN
   DECLARE @V_NRITESUGCOMP INTEGER;
   DECLARE @V_QTCOMPRA     DOUBLE PRECISION;
   DECLARE @V_IDMENSSOLI   VARCHAR(1);
   DECLARE @C_REG_CDPRODUTO VARCHAR(20);
   DECLARE @C_REG_QTITEMPED DOUBLE PRECISION;
   DECLARE @V_DTCORRENT DATETIME;
   DECLARE @V_CDPRODUTO   VARCHAR(10);
   DECLARE @V_CDARVPROD   VARCHAR(20);
   DECLARE @C_CDFILSUGCOMP VARCHAR(4);
   DECLARE @C_QTCOMPRA      DOUBLE PRECISION;
   DECLARE @C_CDPROSUGCOMP  VARCHAR(10);
   DECLARE @V_NRPREVCOMP    VARCHAR(20);
   DECLARE @V_NRSEQPREVI INTEGER;
   DECLARE @V_GEROU_SOLI INTEGER;
   DECLARE @V_PROXCODIGO VARCHAR(20);
   DECLARE @V_RETORNAFUNC DOUBLE PRECISION;

   SET @V_DTCORRENT = GETDATE();
   SET @V_NRITESUGCOMP = 1;
   SET @V_PROXCODIGO = '';

   DECLARE C_REG CURSOR FOR
                 SELECT I.CDPRODUTO, SUM(I.QTITEMPED - QTEXPITEMPED) QTITEMPED
                 FROM
                    ITEMPEDIDO I, PEDIDO P, PRODUTO U
                 WHERE
                   P.CDFILIAL =  @P_CDFILIAL  AND
                   P.IDSITPEDIDO IN( '1','2','3','6') AND
                   ((P.DTPEDIDO BETWEEN @P_DTPEDINI  AND @P_DTPEDFIN)OR((@P_DTPEDINI IS NULL) AND(@P_DTPEDFIN IS NULL)))AND
                   ((@P_CDCLIENTE IS NULL)OR(CHARINDEX( P.CDCLIENTE, @P_CDCLIENTE)>0))AND
                   ((@P_CDFILIDEST IS NULL)OR(CHARINDEX(P.CDFILIALPED, @P_CDFILIDEST)>0))AND
                   ((I.DTENTITPED BETWEEN  @P_DTENTINI AND CONVERT(DATETIME,  @P_DTENTFIN + ' 23:59'))OR((@P_DTENTINI IS NULL) AND(@P_DTENTFIN IS NULL)))AND
                   (CHARINDEX( IDSITITEMPED, @P_IDSITITEMPED) >0)AND
                   U.CDARVPROD BETWEEN @P_CDPRODINI AND @P_CDPRODFIN AND
                   I.CDFILIAL =  P.CDFILIAL AND
                   I.NRPEDIDO =  P.NRPEDIDO AND
                   (I.CDPRODUTO = U.CDPRODUTO) AND
                   NOT EXISTS( SELECT K.NRPEDIDO
                               FROM PEDIDOP K
                               WHERE
                                  K.CDFILIAL = I.CDFILIAL AND
                                  K.NRPEDIDO = I.NRPEDIDO AND
                                  K.NRITEMPED = I.NRITEMPED)
                GROUP BY I.CDPRODUTO;
   OPEN C_REG;
   FETCH NEXT FROM C_REG INTO @C_REG_CDPRODUTO, @C_REG_QTITEMPED;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      EXECUTE TEKNISA.GRAVA_COMPOSICAO_BDL @P_CDFILIAL, @C_REG_CDPRODUTO, @C_REG_QTITEMPED, @V_DTCORRENT,
                                           @P_NRSUGCOMPRA, @P_DTENTINI, @P_DTENTFIN, @P_DTPEDFIN, @P_DTPEDINI, @P_CDFILIDEST, @P_CDCLIENTE, @P_IDSITITEMPED;
      FETCH NEXT FROM C_REG INTO @C_REG_CDPRODUTO, @C_REG_QTITEMPED;
   END;

   CLOSE C_REG;
   DEALLOCATE C_REG;

   IF @P_IDGERASOLCMP  = 'S' BEGIN
      SET @V_GEROU_SOLI = 0;
      SET @P_IDMENSSOLI = '';

      DECLARE C CURSOR FOR
                SELECT CDFILSUGCOMP, CDPROSUGCOMP, QTCOMPRA
                FROM  TRAB_SUGCOMPRA
                WHERE
                   CDFILSUGCOMP = @P_CDFILIAL AND
                   NRSUGCOMPRA  = @P_NRSUGCOMPRA AND
                   QTCOMPRA > 0;

      OPEN C;
      FETCH NEXT FROM C INTO  @C_CDFILSUGCOMP, @C_CDPROSUGCOMP, @C_QTCOMPRA;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         IF @V_GEROU_SOLI = 0 BEGIN

            SET @V_PROXCODIGO = 'NRPREVCOMP'+@P_CDFILIAL;


            EXEC NOVO_CODIGO @V_PROXCODIGO , @P_SEQUENCIAL = @V_NRPREVCOMP OUTPUT, @P_QTDE = 1;
            SET @V_NRPREVCOMP = SUBSTRING(@V_NRPREVCOMP, 11, 10);

            INSERT INTO PREVCOMP
               (CDFILIAL, NRPREVCOMP, CDOPGERPRCOM, DTHRPREVCOMP, IDSTPREVCOMP)
            VALUES
               (@P_CDFILIAL, @V_NRPREVCOMP, @P_CDOPERADOR, GETDATE(), 'P');
            SET @V_GEROU_SOLI = 1;
         END;

         SELECT
            @V_NRSEQPREVI = ISNULL(MAX(NRITPREVCOMP), 0) + 1
         FROM
            ITPREVCOMP
         WHERE
            CDFILIAL   = @P_CDFILIAL    AND
            NRPREVCOMP = @V_NRPREVCOMP;

         INSERT INTO ITPREVCOMP
            (CDFILIAL, NRPREVCOMP, NRITPREVCOMP, CDPRODUTO,  DTENTPRECOMP, QTPREVCOMP)
         VALUES
            (@P_CDFILIAL, @V_NRPREVCOMP , RIGHT(REPLICATE('0',4) + CONVERT(VARCHAR,
             @V_NRSEQPREVI), 4) , @C_CDPROSUGCOMP, @P_DTENTSOLI, @C_QTCOMPRA);

         FETCH NEXT FROM C INTO  @C_CDFILSUGCOMP, @C_CDPROSUGCOMP, @C_QTCOMPRA;
      END;

      CLOSE C;
      DEALLOCATE C;

      DELETE FROM  TRAB_SUGCOMPRA
      WHERE
         CDFILSUGCOMP = @P_CDFILIAL AND
         NRSUGCOMPRA  = @P_NRSUGCOMPRA;

      IF @V_GEROU_SOLI = 1 BEGIN
         SET @P_IDMENSSOLI = @V_NRPREVCOMP;
      END
      ELSE BEGIN
         SET @P_IDMENSSOLI = '3';
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_SUGESTAO_COMPRA_BDL','5.09.014';
GO
