/* TEKNISA

Nome: 7600_PMEPKGS_UTIL_CONSPLAN_PME.SQL

Descrio:
Rotinas e cursores auxiliares para clculo do consumo planejado

Criao:
09/02/2006 - Rafael Christopher de Souza e Silva

*/
   /* --- PROCEDURE QUE ATUALIZA A CONSPLAN VERIFICANDO SE  NECESSARIA A --- */
   /* --------------------- INCLUSAO OU ALTERACAO --------------------------- */

IF EXISTS(SELECT name FROM sysobjects
          WHERE name = 'ATUALIZA_CONSPLAN_PME' AND type = 'P')
DROP PROCEDURE ATUALIZA_CONSPLAN_PME
GO

CREATE PROCEDURE ATUALIZA_CONSPLAN_PME
                            @P_NRCONSPLAN          VARCHAR(10),
                            @P_CDFILCENTPME        VARCHAR(4),
                            @P_CDFILIAL            VARCHAR(4),
                            @P_CDTIPOCARD          VARCHAR(10),
                            @CONS_REC_CDSERVFILI   VARCHAR(5),
                            @P_IDCONSPLAN      	   VARCHAR(1),
                            @P_CDFAPRATCPME    	   VARCHAR(4),
                            @P_CDPRATCONSPL        VARCHAR(10),
                            @P_CDAPRECONSPL        VARCHAR(3),
                            @P_CDSETOCONSPL        VARCHAR(2),
                            @P_CDPRODCPME          VARCHAR(10),
                            @P_DTLIMITECPME    	   DATETIME,
                            @P_HRLIMITECPME    	   VARCHAR(4),
                            @P_CDTPPRATCPME    	   VARCHAR(2),
                            @P_QTCONSPLAN      	   NUMERIC(15,5),
                            @P_VRPECONSPLAN    	   FLOAT,
                            @P_QTCOMESTCPME    	   NUMERIC(10,3),
                            @P_AJUSHRLIMI      	   VARCHAR(1),
                            @CONS_REC_DTCARDIAPME  DATETIME
AS
   DECLARE @V_CONTAUXI     NUMERIC;
   DECLARE @V_QTCOMESTCPME NUMERIC(10,3);
   DECLARE @V_QTCONSPLAN   NUMERIC(15,5);
   
BEGIN
   SET @V_CONTAUXI = 0;
   SET @V_QTCOMESTCPME = @P_QTCOMESTCPME;

   IF @V_QTCOMESTCPME = 0 BEGIN
      SET @V_QTCOMESTCPME = 1;
   END;

   SELECT
      @V_CONTAUXI = COUNT(*)
   FROM
      CONSPLAN
   WHERE
      (NRCONSPLAN   = @P_NRCONSPLAN        ) AND
      (CDFILCENTPME = @P_CDFILCENTPME      ) AND
      (CDFILICPLA   = @P_CDFILIAL          ) AND
      (CDTPCARDPME  = @P_CDTIPOCARD        ) AND
      (CDSERVCPLA   = @CONS_REC_CDSERVFILI ) AND
      (DTCONSPLAN   = @CONS_REC_DTCARDIAPME) AND
      (IDCONSPLAN   = @P_IDCONSPLAN        ) AND
      (CDFAPRATCPLA = @P_CDFAPRATCPME      ) AND
      (CDTPPRATCPLA = @P_CDTPPRATCPME      ) AND
      (CDPRATCONSPL = @P_CDPRATCONSPL      ) AND
      (CDPRODCPLA   = @P_CDPRODCPME        );

   /* --------------- VERIFICA SE PRODUTO JA ESTA CADASTRADO ------------- */

   IF @V_CONTAUXI = 0 BEGIN
      INSERT INTO CONSPLAN
         (NRCONSPLAN,
          CDFILCENTPME,
          CDFILICPLA,
          CDTPCARDPME,
          CDSERVCPLA,
          DTCONSPLAN,
          IDCONSPLAN,
          CDFAPRATCPLA,
          CDPRATCONSPL,
          CDAPRECONSPL,
          CDSETOCONSPL,
          CDPRODCPLA,
          DTLIMITECPLA,
          HRLIMITECPLA,
          CDTPPRATCPLA,
          QTCONSPLAN,
          VRPECONSPLAN,
          QTCOMESTCPLA,
          CDCLIECPLA,
          CDDESTFICPLA)
      VALUES
         (@P_NRCONSPLAN,
          @P_CDFILCENTPME,
          @P_CDFILIAL,
          @P_CDTIPOCARD,
          @CONS_REC_CDSERVFILI,
          @CONS_REC_DTCARDIAPME,
          @P_IDCONSPLAN,
          @P_CDFAPRATCPME,
          @P_CDPRATCONSPL,
          @P_CDAPRECONSPL,
          @P_CDSETOCONSPL,
          @P_CDPRODCPME,
          CONVERT(DATETIME, CONVERT(VARCHAR, @CONS_REC_DTCARDIAPME, 103), 103),
          @P_HRLIMITECPME,
          @P_CDTPPRATCPME,
          @P_QTCONSPLAN,
          @P_VRPECONSPLAN,
          @V_QTCOMESTCPME,
          'xxx',
          'xxx');
   END
   ELSE BEGIN
      IF (@P_IDCONSPLAN = 'F') BEGIN
         SET @V_QTCONSPLAN = 0;
      END
      ELSE BEGIN
         SET @V_QTCONSPLAN =  @P_QTCONSPLAN;
      END;

      UPDATE
         CONSPLAN
      SET
         QTCONSPLAN = QTCONSPLAN + @V_QTCONSPLAN
      WHERE
         (NRCONSPLAN   = @P_NRCONSPLAN        ) AND
         (CDFILCENTPME = @P_CDFILCENTPME      ) AND
         (CDFILICPLA   = @P_CDFILIAL          ) AND
         (CDTPCARDPME  = @P_CDTIPOCARD        ) AND
         (CDSERVCPLA   = @CONS_REC_CDSERVFILI ) AND
         (DTCONSPLAN   = @CONS_REC_DTCARDIAPME) AND
         (IDCONSPLAN   = @P_IDCONSPLAN        ) AND
         (CDFAPRATCPLA = @P_CDFAPRATCPME      ) AND
         (CDPRATCONSPL = @P_CDPRATCONSPL      ) AND
         (CDTPPRATCPLA = @P_CDTPPRATCPME      ) AND
         (CDPRODCPLA   = @P_CDPRODCPME        );
   END; /* VERIFICAO DA EXISTENCIA DO PRODUTO */
END; /*ATUALIZA_CONSPLAN*/
GO


-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_CONSPLAN','5.05.009';
GO
